﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Drawing;
using System.Reflection;
using System.Windows.Forms;
using System.Runtime.InteropServices;

namespace NHikPlayer
{
    partial class FormInfo : Form
    {
        private Label lblTitle;
        private Button btnOk;
        private Line line;
        private Button btnRefresh;
        private ListView lsvDetail;
        private ColumnHeader columnHeaderKey;
        private ColumnHeader columnHeaderValue;

        private int nPort = 0;
        private int dwRows = 0;
        private bool bInit = false;

        /// <summary>
        /// 必需的设计器变量。
        /// </summary>
        private System.ComponentModel.IContainer components = null;

        /// <summary>
        /// 清理所有正在使用的资源。
        /// </summary>
        protected override void Dispose(bool disposing)
        {
            if (disposing && (components != null))
            {
                components.Dispose();
            }
            base.Dispose(disposing);
        }

        #region Windows 窗体设计器生成的代码

        /// <summary>
        /// 设计器支持所需的方法 - 不要
        /// 使用代码编辑器修改此方法的内容。
        /// </summary>
        private void InitializeComponent()
        {
            this.lblTitle = new System.Windows.Forms.Label();
            this.btnOk = new System.Windows.Forms.Button();
            this.btnRefresh = new System.Windows.Forms.Button();
            this.lsvDetail = new System.Windows.Forms.ListView();
            this.columnHeaderKey = new System.Windows.Forms.ColumnHeader();
            this.columnHeaderValue = new System.Windows.Forms.ColumnHeader();
            this.line = new NHikPlayer.Line();
            this.SuspendLayout();
            // 
            // lblTitle
            // 
            this.lblTitle.AutoSize = true;
            this.lblTitle.Font = new System.Drawing.Font("黑体", 12F, System.Drawing.FontStyle.Bold, System.Drawing.GraphicsUnit.Point, ((byte)(134)));
            this.lblTitle.ForeColor = System.Drawing.Color.SteelBlue;
            this.lblTitle.Location = new System.Drawing.Point(114, 12);
            this.lblTitle.Name = "lblTitle";
            this.lblTitle.Size = new System.Drawing.Size(110, 16);
            this.lblTitle.TabIndex = 0;
            this.lblTitle.Text = "视频统计信息";
            // 
            // btnOk
            // 
            this.btnOk.Location = new System.Drawing.Point(257, 315);
            this.btnOk.Name = "btnOk";
            this.btnOk.Size = new System.Drawing.Size(75, 23);
            this.btnOk.TabIndex = 4;
            this.btnOk.Text = "确定";
            this.btnOk.UseVisualStyleBackColor = true;
            this.btnOk.Click += new System.EventHandler(this.btnOk_Click);
            // 
            // btnRefresh
            // 
            this.btnRefresh.Location = new System.Drawing.Point(81, 315);
            this.btnRefresh.Name = "btnRefresh";
            this.btnRefresh.Size = new System.Drawing.Size(75, 23);
            this.btnRefresh.TabIndex = 3;
            this.btnRefresh.Text = "刷新";
            this.btnRefresh.UseVisualStyleBackColor = true;
            this.btnRefresh.Click += new System.EventHandler(this.btnRefresh_Click);
            // 
            // lsvDetail
            // 
            this.lsvDetail.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
            this.columnHeaderKey,
            this.columnHeaderValue});
            this.lsvDetail.FullRowSelect = true;
            this.lsvDetail.GridLines = true;
            this.lsvDetail.Location = new System.Drawing.Point(24, 52);
            this.lsvDetail.Name = "lsvDetail";
            this.lsvDetail.Size = new System.Drawing.Size(324, 247);
            this.lsvDetail.TabIndex = 2;
            this.lsvDetail.UseCompatibleStateImageBehavior = false;
            this.lsvDetail.View = System.Windows.Forms.View.Details;
            // 
            // columnHeaderKey
            // 
            this.columnHeaderKey.Text = "选项";
            this.columnHeaderKey.Width = 180;
            // 
            // columnHeaderValue
            // 
            this.columnHeaderValue.Text = "值";
            this.columnHeaderValue.Width = 140;
            // 
            // line
            // 
            this.line.Location = new System.Drawing.Point(12, 37);
            this.line.Name = "line";
            this.line.Size = new System.Drawing.Size(350, 10);
            this.line.TabIndex = 1;
            this.line.Text = "line1";
            // 
            // FormInfo
            // 
            this.AcceptButton = this.btnOk;
            this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 12F);
            this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
            this.ClientSize = new System.Drawing.Size(374, 349);
            this.Controls.Add(this.lsvDetail);
            this.Controls.Add(this.btnRefresh);
            this.Controls.Add(this.line);
            this.Controls.Add(this.btnOk);
            this.Controls.Add(this.lblTitle);
            this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
            this.MaximizeBox = false;
            this.MinimizeBox = false;
            this.Name = "FormInfo";
            this.Padding = new System.Windows.Forms.Padding(9, 8, 9, 8);
            this.ShowIcon = false;
            this.ShowInTaskbar = false;
            this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
            this.Text = "统计信息";
            this.Load += new System.EventHandler(this.FormInfo_Load);
            this.ResumeLayout(false);
            this.PerformLayout();

        }
        #endregion

        public FormInfo(int Port)
        {
            InitializeComponent();
            nPort = Port;
        }

        private void FormInfo_Load(object sender, EventArgs e)
        {
            GetDrawDeviceInfo();
            bInit = true;
        }

        private void btnRefresh_Click(object sender, EventArgs e)
        {
            GetDrawDeviceInfo();
        }

        private void btnOk_Click(object sender, EventArgs e)
        {
            this.Close();
        }

        private void GetDrawDeviceInfo()
        {
            int nRows = 0;

            #region 设备
            if (HikPlayer.WINVER >= 0x0400)
            {
                int nVal = HikPlayer.PlayM4_GetDDrawDeviceTotalNums();
                if (!bInit)
                {
                    if (nVal >= 1)
                    {
                        ListViewItem lsvItem1 = new ListViewItem("显示设备数");
                        lsvItem1.SubItems.Add(nVal.ToString());
                        lsvDetail.Items.Add(lsvItem1);
                        nRows++;

                        for (int nCount = 1; nCount <= nVal; nCount++)
                        {
                            string lpDriverDesp = string.Empty;
                            string lpDriverName = string.Empty;
                            ushort nDespLen = 50;
                            ushort nNameLen = 50;
                            IntPtr hMonitor = new IntPtr();

                            HikPlayer.PlayM4_GetDDrawDeviceInfo(nVal, lpDriverDesp, nDespLen, lpDriverName, nNameLen, hMonitor);

                            ListViewItem lsvItem1_1 = new ListViewItem(string.Format("----设备<{0}>", nCount - 1));
                            lsvItem1_1.SubItems.Add(lpDriverDesp);
                            lsvDetail.Items.Add(lsvItem1_1);
                            nRows++;

                            ListViewItem lsvItem1_2 = new ListViewItem(string.Format("----驱动<{0}>", nCount - 1));
                            lsvItem1_2.SubItems.Add(lpDriverName);
                            lsvDetail.Items.Add(lsvItem1_2);
                            nRows++;
                        }
                    }
                    else
                    {
                        ListViewItem lsvItem1 = new ListViewItem("只有主显示设备");
                        lsvItem1.SubItems.Add("none");
                        lsvDetail.Items.Add(lsvItem1);
                        nRows++;
                    }
                    dwRows = nRows;
                }
                else
                {
                    nRows = dwRows;
                }
            }
            #endregion

            #region 是否是覆盖表面
            int bOverlay = HikPlayer.PlayM4_GetOverlayMode(nPort);
            int colorTmp = (int)HikPlayer.PlayM4_GetColorKey(nPort);
            int red = colorTmp & 255;
            int green = colorTmp >> 8 & 255;
            int blue = colorTmp >> 16 & 255;
            string strItem = string.Empty;
            if (!bInit)
            {
                ListViewItem lsvItem2 = new ListViewItem("是否是覆盖表面");
                //if (bOverlay == 1)
                strItem = string.Format("是(关键色:#{0:X000}{1:X000}{2:X000})", red, green, blue);
                //else
                //    strItem = "否";
                lsvItem2.SubItems.Add(strItem);
                lsvDetail.Items.Add(lsvItem2);
            }
            else
            {
                //if (bOverlay == 1)
                    strItem = string.Format("是(关键色:#{0:X000}{1:X000}{2:X000})", red, green, blue);
                //else
                //    strItem = "否";
                lsvDetail.Items[nRows].SubItems[1].Text = strItem;
            }
            nRows++;
            #endregion

            #region 总播放链表缓冲(帧)
            ushort displayBuf = HikPlayer.PlayM4_GetDisplayBuf(nPort);
            if (!bInit)
            {
                ListViewItem lsvItem3 = new ListViewItem("总播放链表缓冲(帧)");
                lsvItem3.SubItems.Add(string.Format("{0:D}", displayBuf));
                lsvDetail.Items.Add(lsvItem3);
            }
            else
            {
                lsvDetail.Items[nRows].SubItems[1].Text = string.Format("{0:D}", displayBuf);
            }
            nRows++;
            #endregion

            #region 音量
            float uVolume = HikPlayer.PlayM4_GetVolume(nPort) / 65535;
            if (!bInit)
            {
                ListViewItem lsvItem4 = new ListViewItem("音量");
                lsvItem4.SubItems.Add(string.Format("{0:P0}", uVolume));
                lsvDetail.Items.Add(lsvItem4);
            }
            else
            {
                lsvDetail.Items[nRows].SubItems[1].Text = string.Format("{0:P0}", uVolume);
            }
            nRows++;
            #endregion

            #region 图像质量
            bool bHiQuality = false;
            HikPlayer.PlayM4_GetPictureQuality(nPort, out bHiQuality);
            if (!bInit)
            {
                ListViewItem lsvItem5 = new ListViewItem("图像质量");
                lsvItem5.SubItems.Add(bHiQuality ? "高" : "低");
                lsvDetail.Items.Add(lsvItem5);
            }
            else
            {
                lsvDetail.Items[nRows].SubItems[1].Text = bHiQuality ? "高" : "低";
            }
            nRows++;
            #endregion

            #region 当前时钟
            ushort pTimeType = 1;
            ushort pReserved = 0;
            HikPlayer.PlayM4_GetTimerType(nPort, out pTimeType, out pReserved);
            ListViewItem lsvItem6 = new ListViewItem("当前时钟");
            if (!bInit)
            {
                lsvItem6.SubItems.Add(pTimeType == HikPlayer.TIMER_1 ? "TIMER_1" : "TIMER_2");
                lsvDetail.Items.Add(lsvItem6);
            }
            else
            {
                lsvDetail.Items[nRows].SubItems[1].Text = pTimeType == HikPlayer.TIMER_1 ? "TIMER_1" : "TIMER_2";
            }
            nRows++;
            #endregion

            #region 当前视频/音频缓冲
            ushort nVideoRender = HikPlayer.PlayM4_GetBufferValue(nPort, HikPlayer.BUF_VIDEO_RENDER);
            ushort nAudioRender = HikPlayer.PlayM4_GetBufferValue(nPort, HikPlayer.BUF_AUDIO_RENDER);
            ushort nVideoSource = HikPlayer.PlayM4_GetBufferValue(nPort, HikPlayer.BUF_VIDEO_SRC);
            ushort nAudioSource = HikPlayer.PlayM4_GetBufferValue(nPort, HikPlayer.BUF_AUDIO_SRC);

            if (!bInit)
            {
                ListViewItem lsvItem7 = new ListViewItem("视频缓冲帧数(帧)");
                lsvItem7.SubItems.Add(string.Format("{0:D}", nVideoRender));
                lsvDetail.Items.Add(lsvItem7);
            }
            else
            {
                lsvDetail.Items[nRows].SubItems[1].Text = string.Format("{0:D}", nVideoRender);
            }
            nRows++;

            if (!bInit)
            {
                ListViewItem lsvItem8 = new ListViewItem("音频缓冲块数(块)");
                lsvItem8.SubItems.Add(string.Format("{0:D}", nAudioRender));
                lsvDetail.Items.Add(lsvItem8);
            }
            else
            {
                lsvDetail.Items[nRows].SubItems[1].Text = string.Format("{0:D}", nAudioRender);
            }
            nRows++;

            if (!bInit)
            {
                ListViewItem lsvItem9 = new ListViewItem("视频源缓冲大小(流方式)");
                lsvItem9.SubItems.Add(string.Format("{0:D}", nVideoSource));
                lsvDetail.Items.Add(lsvItem9);
            }
            else
            {
                lsvDetail.Items[nRows].SubItems[1].Text = string.Format("{0:D}", nVideoSource);
            }
            nRows++;

            if (!bInit)
            {
                ListViewItem lsvItem10 = new ListViewItem("音频源缓冲大小(流方式)");
                lsvItem10.SubItems.Add(string.Format("{0:D}", nAudioSource));
                lsvDetail.Items.Add(lsvItem10);
            }
            else
            {
                lsvDetail.Items[nRows].SubItems[1].Text = string.Format("{0:D}", nAudioSource);
            }
            nRows++;
            #endregion
        }
    }
}
